//---------------------------------------------------------------------------
#ifndef MsgBoxH
#define MsgBoxH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
namespace TMsgBoxNS
{

enum MsgBoxTypes
{
	mbAsk, mbInfo, mbWarn, mbError, mbCustom
};

enum Appearences
{
	apCustom=0,apDefault,apParentCenter,apScreenCenter
};

enum MsgButtonStyles
{
	btsAbortRetryIgnore,
	btsOk,
    btsOkCancel,
    btsRetryCancel,
    btsYesNo,
    btsYesNoCancel,
    btsCustom
};

class TMsgBox : public TComponent
{
private:
	TForm               *frm;
    TWinControl			*CurParArea;
   	Appearences 		FAppearence;
   	MsgBoxTypes 		FType;
    MsgButtonStyles     FStyles;
   	Graphics::TBitmap 	*FCustomImage;
    AnsiString          FCaption;
    TStringList			*FLines;
    TStringList         *FButtonTexts;
    int					FAVIResourceID;
    AnsiString 			FAVIResourceName;
    AnsiString			FAVIFile;
   	int 				FLeft, FTop;
    int 				FDefButton;
    int                 FResult;
    // new
    TImageList			*PreImages;
    TButton				*Buttons[10];
    TLabel 				*lab;
	TWinControl			*as;
    TColor				FTransparentColor;
    int 				FCancelButton;
    // new
private:
	void __fastcall getPreImage(char *RsrcStr);
	void __fastcall frmPaint(TObject *Sender);
protected:
	virtual void __fastcall CalcControlSizes(void);
	virtual void __fastcall SetCustomImage(Graphics::TBitmap *bm);
	virtual Graphics::TBitmap * __fastcall GetCustomImage(void);
    virtual void __fastcall SetLines(TStringList *sl);
    virtual TStringList * __fastcall GetLines(void);
    virtual void __fastcall SetButtonTexts(TStringList *sl);
    virtual TStringList * __fastcall GetButtonTexts(void);
    virtual void __fastcall BtnClicked(TObject *Sender);
public:
	__fastcall TMsgBox(TComponent* Owner);
    int __fastcall Execute(TWinControl *ParArea);
__published:
    __property MsgButtonStyles ButtonStyles = {read=FStyles, write=FStyles, default=btsOk, stored=true};
	__property Appearences Appearence = {read=FAppearence, write=FAppearence, default=apScreenCenter, stored=true};
	__property MsgBoxTypes Type = {read=FType, write=FType, default=mbAsk, stored=true};
    __property TStringList *Lines = {read=GetLines, write=SetLines, nodefault, stored=true};
    __property TStringList *ButtonTexts = {read=GetButtonTexts, write=SetButtonTexts, nodefault, stored=true};
	__property AnsiString Caption = {read=FCaption, write=FCaption, stored=true};
    __property Graphics::TBitmap *CustomImage = {read=GetCustomImage, write=SetCustomImage, stored=true, nodefault};
	__property int FormLeft = {read=FLeft, write=FLeft, default=20, stored=true};
	__property int FormTop = {read=FTop, write=FTop, default=20, stored=true};
    __property int DefButton = {read=FDefButton, write=FDefButton, default=0, stored=true};
    __property int CancelButton = {read=FCancelButton, write=FCancelButton, default=0, stored=true};
    __property int Result = {read=FResult, default=0, stored=false};
    __property int AVIResourceID = {read=FAVIResourceID, write=FAVIResourceID, default=-1, stored=true};
	__property AnsiString AVIResourceName = {read=FAVIResourceName, write=FAVIResourceName, nodefault, stored=true};
    __property AnsiString AVIFile = {read=FAVIFile, write=FAVIFile, nodefault, stored=true};
	__property TColor TransparentColor={read=FTransparentColor,write=FTransparentColor,
		default=clNone,stored=true};
};

} // end NS

using namespace TMsgBoxNS;
//---------------------------------------------------------------------------
#endif
